        include "tios.h"
        include "flib.h"
        include "tidos.h"
        include "keys.h"
        xdef    _library
        xdef    doslib@0000
        xdef    doslib@0001
        xdef    doslib@0002
        xdef    doslib@0003
        xdef    doslib@0004
        xdef    doslib@0005
        xdef    doslib@0006
        xdef    doslib@0007
        xdef    doslib@0008
        xdef    doslib@0009
        xdef    doslib@000A
        xdef    doslib@000B
        xdef    doslib@000C
        xdef    doslib@000D
        xdef    doslib@000E
        xdef    doslib@000F
        xdef    doslib@0010
        xdef    doslib@0011
        xdef    doslib@0012
        xdef    doslib@0013
        xdef    doslib@0014
;--------------------------------------------------;
;               Shared Variables                   ;
;--------------------------------------------------;
doslib@0000     dc.w    0               ;line_pos
line_pos        EQU     doslib@0000
doslib@0001     dc.w    0               ;char_pos
char_pos        EQU     doslib@0001
doslib@0002     dc.b    "main",0,0,0,0,0;cur_fold
cur_fold        EQU     doslib@0002
doslib@0003     dc.w    0               ;cur_fold_hand
cur_fold_hand   EQU     doslib@0003
doslib@0009     dc.w    0
comm_offset     EQU     doslib@0009
doslib@000E     dc.w    0
status_word     EQU     doslib@000E
doslib@0011     dc.b    "Required parameter missing",0,0        ;Even!
doslib@0013     dc.b    "Invalid switch - ",0                   ;Even!
doslib@0014     dc.b    "File not found",0,0                    ;EVEN!
;--------------------------------------------------;
;               Shared Subroutines                 ;
;--------------------------------------------------;
doslib@0004:                            ;WORD Getche()
        jsr     flib::idle_loop
        cmp.w   #ENTER,d0
        beq     \skip_output
        cmp.w   #BKSPC,d0
        beq     \skip_output
        move.w  d0,-(sp)                ;store away the key
        PutChar d0,line_pos,char_pos
        move.w  (sp)+,d0                ;retrieve key
\skip_output:
        rts


doslib@0005:                            ;VOID Scroll()
        cmp.w   #MAX_LINES,line_pos
        blt     \exit_no_scroll             ;if < 14, exit
        CreateHdl       scrbuf_hdlnum,#SIZE_SCR_BUF;returns a0 = hdl address
        move.l  #SIZE_SCR_BUF,-(sp)             ;push size
        move.l  #LCD_MEM+270,-(sp)      ;push add. of source of info
        move.l  a0,-(sp)                ;push add. of destination of info
        jsr     tios::memcpy            ;copy mem from screen to buffer
        lea     12(sp),sp               ;a0 still holds the add. of buffer
        jsr     flib::zap_screen
        move.l  #SIZE_SCR_BUF,-(sp)             ;push size
        move.l  a0,-(sp)                ;push add. of source of info
        move.l  #LCD_MEM,-(sp)          ;push add. of dest of info
        jsr     tios::memcpy            ;copy mem from buffer to screen
        lea     12(sp),sp
        DestroyHdl      scrbuf_hdlnum   ;destroys screen buff
        rts
\exit_no_scroll:
        addq.w  #1,line_pos
        rts
                                     ;size_t PutText(BYTE *str)
doslib@0006:           ;a0=pointer to string 
                        ;output: d0.l = length of whatever has been printed
        move.w  #4,-(sp)        ;push color
        move.l  a0,-(sp)        ;push pointer to null terminated string
        move.w  line_pos,d1
        mulu.w  #LINE_WIDTH,d1  ;d1 = Y
        add.w   #1,d1           ;reduces flicker
        move.w  d1,-(sp)        ;push Y
        move.w  char_pos,d1           
        mulu.w  #CHAR_WIDTH,d1  ;d1 = X
        move.w  d1,-(sp)        ;push X
        jsr     tios::DrawStrXY ;print the text
        lea     4(sp),sp        ;partially update stack
        move.l  (sp)+,a0        ;pop pointer to string
        lea     2(sp),sp        ;finish updating
        move.l  a0,-(sp)        ;push pointer
        jsr     tios::strlen    ;get length
        lea     4(sp),sp        ;update
        rts
PutText         EQU     doslib@0006

doslib@0007     ds.w    5
command         EQU     doslib@0007
doslib@0008     ds.b    LINE_LENGTH      ;
command_buffer  EQU     doslib@0008

doslib@000A                             ; size_t GetNextComm()
        move.l  #command_buffer,a2   
        add.w   comm_offset,a2  ;get the "current" next command
        move.l  #10,-(sp)   ;push size of one command
        move.w  #0,-(sp)                ;push char
        move.l  #command,-(sp)                ;push add
        jsr     tios::memset            ;clear doslib::command mem area
        lea     10(sp),sp
        move.l  a2,-(sp)        ;push string add.
        jsr     tios::strlen    ;get length
        lea     4(sp),sp        ;update stack
        tst.l   d0              ;was there a command?
        beq     no_command
        add.w   d0,comm_offset      ;point to "next" next command
        add.w   #1,comm_offset      ;to account for the null byte
        move.l  d0,-(sp)        ;push lenght
        move.l  a2,-(sp)        ;push source
        move.l  #command,-(sp)        ;push dest
        jsr     tios::strncpy   ;copy data
        lea     8(sp),sp        ;partially update
        move.l  (sp)+,d0        ;pop size back
no_command:
        rts

doslib@000B:                            ;void PrintPath()
        clr.w   char_pos
        lea     drive_ram(PC),a0
        jsr     PutText           
        add.w   d0,char_pos
        lea     separator(PC),a0
        jsr     PutText           
        add.w   #SEPARATOR_LEN,char_pos
        move.w  cur_fold_hand,d0          ;are we in the root directory?
        cmp.w   FOLDER_LIST_HANDLE,d0
        beq     dont_put_fold
        move.l  #cur_fold,a0
        jsr     PutText           
        add.w   d0,char_pos
dont_put_fold:
        rts

doslib@000C:                  ;BYTE *GetDataType(SYM_STRUCT *file)
       ;input: a1 = add. of sym struct. out: a0=type string
        move.w  tios::SYM_ENTRY.hVal(a1),d0     ;handle of the file
        tios::DEREF d0,a0           ;address of the file
        move.w  (a0),d0                         ;size of the file
        move.b  1(a0,d0.w),d1                   ;get data type
        cmp.b   #$DC,d1                         ;is prog?
        beq     prog_or_func
        lea     stuff(PC),a0
        rts
prog_or_func:
        adda.l  #4,a0
        cmp.b   #E_UPPER,(a0)
        beq     fargo_file
        lea     prog(PC),a0
        rts
fargo_file:
        adda.l  #4,a0           ;get fargo file type (APPL, LIB, etc)
        rts

doslib@000D:                    ;SYM_STRUCT *GetStructCurFold()
        move.l  #cur_fold,-(sp)
        move.w  FOLDER_LIST_HANDLE,-(sp)
        jsr     tios::FindSymEntry
        lea     6(sp),sp
        rts

doslib@000F:                    ; void DosNotRunning()
        pea     dos_no_run(PC)
        jsr     tios::ST_showHelp
        lea     4(sp),sp
        jsr     flib::idle_loop
        rts

doslib@0010:                    ;void Cls()
        jsr     flib::zap_screen
        move.w  #-1,line_pos    ;-1 because Scroll() will add 1
        clr.w   char_pos
        rts

doslib@0012:                    ;size_t ConvHexToBin(unsigned int num)
        lea     dec_str(PC),a0  ;load the pointer to output string
        move.l  d0,-(sp)        ;store away d0
        move.l  #6,-(sp)        ;push # bytes
        move.w  #0,-(sp)        ;push char to set
        move.l  a0,-(sp)        ;push pointer to mem
        jsr     tios::memset    ;clear the mem
        lea     10(sp),sp
        move.l  (sp)+,d0        ;pop back d0
        tst.w   d0
        bne     input_not_0
        move.b  #ZERO,(a0)      ;put "0"
        bra     conv_done
input_not_0
        move.w  #4,d2           ;set up counter
        move.l  #10000,d1       ;start out dividing by 10^4
division:
        divu    d1,d0           ;d0 was input
        tst.w   d0              ;zero?
        bne     continue        ;if the first digits aren't 0, proceed normally
        clr.w   d0
        swap    d0
        divu    #10,d1          ;if the first digits are 0, go down a power,
        subq.w  #1,d2           ;decrement future counter
        bra     division        ;try again
continue:
        move.b  d0,(a0)
        add.b   #ZERO,(a0)+     ;write the digit character
        clr.w   d0              ;get rid of division result
div_skip:
        swap    d0              ;get remainder
        divu    #10,d1          ;go down a power of 10
        tst.w   d1              ;0?
        beq     conv_done
        divu    d1,d0
        dbra.w  d2,continue     ;repeat
conv_done:
        lea     dec_str(PC),a0  ;load the pointer to string
        bsr     PutText         ;print it
        rts

_library        dc.b    "doslib",0
scrbuf_hdlnum   dc.w    0
drive_ram       dc.b    "Ram",0
separator       dc.b    ":\>",0
dos_no_run      dc.b    "TiDOS is not running",0
stuff           dc.b    "stuff",0
prog            dc.b    "prog",0
dec_str         ds.w    3       ;5 chars + NULL


        end
